package com.utopiaindustries.hseobservationsapp.activities.ObservationForms;

import android.content.Intent;
import android.os.Bundle;
import android.util.Log;
import android.view.View;
import android.widget.AdapterView;
import android.widget.AutoCompleteTextView;
import android.widget.Button;
import android.widget.ImageView;
import android.widget.Toast;

import androidx.activity.EdgeToEdge;
import androidx.appcompat.app.AppCompatActivity;
import androidx.core.graphics.Insets;
import androidx.core.view.ViewCompat;
import androidx.core.view.WindowInsetsCompat;

import com.utopiaindustries.hseobservationsapp.R;
import com.utopiaindustries.hseobservationsapp.adapters.ObservationClassAdapter;
import com.utopiaindustries.hseobservationsapp.adapters.ObservationSubClassAdapter;
import com.utopiaindustries.hseobservationsapp.adapters.ShiftAdapter;
import com.utopiaindustries.hseobservationsapp.helper.Helper;
import com.utopiaindustries.hseobservationsapp.models.HseData.HseObservationClass;
import com.utopiaindustries.hseobservationsapp.models.HseData.HseObservationSubClass;
import com.utopiaindustries.hseobservationsapp.models.HseData.Site;
import com.utopiaindustries.hseobservationsapp.models.Shift;

import java.util.ArrayList;
import java.util.List;
import java.util.Objects;
import java.util.stream.Collectors;

public class ObservationOneActivity extends AppCompatActivity {

    private AutoCompleteTextView observationTextview, observationSubTextview;

    private ObservationClassAdapter observationClassAdapter;
    private ObservationSubClassAdapter observationSubClassAdapter;
    private ArrayList<HseObservationClass> obClassArrayList = new ArrayList<>();

    private ArrayList<HseObservationSubClass> obSubClassArrayList_temp = new ArrayList<>();
    private ArrayList<HseObservationSubClass> obSubClassArrayList = new ArrayList<>();

    private Button btnNext;
    ImageView imgBack;

    String observationClass = "", observationSubClass = "";
    int observationClassId = 0, observationSubClassId = 0;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        EdgeToEdge.enable(this);
        setContentView(R.layout.activity_observation_one);
        ViewCompat.setOnApplyWindowInsetsListener(findViewById(R.id.main), (v, insets) -> {
            Insets systemBars = insets.getInsets(WindowInsetsCompat.Type.systemBars());
            v.setPadding(systemBars.left, systemBars.top, systemBars.right, systemBars.bottom);
            return insets;
        });

        initializeLayout();

        imgBack.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                finish();
            }
        });

        btnNext.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
               // if (isValidate()) {
                    if (observationClass.equalsIgnoreCase("Near Miss")) {
                        Intent intent = new Intent(ObservationOneActivity.this, ObservationNearMissActivity.class);
                        startActivity(intent);
                    }
                    else {
                        Intent intent = new Intent(ObservationOneActivity.this, ObservationTwoActivity.class);
                        startActivity(intent);
                    }

               // }
            }
        });

        observationTextview.setOnItemClickListener(new AdapterView.OnItemClickListener() {
            @Override
            public void onItemClick(AdapterView<?> parent, View view, int position, long id) {
                // Perform action when shiftTextview item is clicked
                //Toast.makeText(ObservationOneActivity.this, "Item clicked: " + obClassArrayList.get(position).getTitle(), Toast.LENGTH_SHORT).show();
                observationClass = obClassArrayList.get(position).getTitle();
                HseObservationClass clickedItem = obClassArrayList.get(position);

                observationSubTextview.setText(null);

                Log.e("ob-Sub-Class: ",""+obSubClassArrayList_temp.size());
                if (!obSubClassArrayList_temp.isEmpty()) {

                    List<HseObservationSubClass> filteredUnitItems = obSubClassArrayList_temp.stream()
                            .filter(item -> Objects.equals(item.getObservationClassId(), clickedItem.getId()))
                            .collect(Collectors.toList());

                    Log.e("clickedItem.getId(): ",""+clickedItem.getId());
                    Log.e("filteredUnitItems: ",""+filteredUnitItems.size());

                    for (int i = 0; i < obSubClassArrayList_temp.size(); i++) {
                        Log.e("Sub-Items: ",""+obSubClassArrayList_temp.get(i).getId());
                    }

                    obSubClassArrayList.clear();
                    obSubClassArrayList.addAll(filteredUnitItems);
                    observationSubClassAdapter = new ObservationSubClassAdapter(ObservationOneActivity.this, filteredUnitItems);
                    observationSubTextview.setAdapter(observationSubClassAdapter);

                }
            }
        });

        observationSubTextview.setOnItemClickListener(new AdapterView.OnItemClickListener() {
            @Override
            public void onItemClick(AdapterView<?> parent, View view, int position, long id) {
                // Perform action when shiftTextview item is clicked
                //Toast.makeText(ObservationOneActivity.this, "Item clicked: " + obSubClassArrayList.get(position).getTitle(), Toast.LENGTH_SHORT).show();

            }
        });
    }

    public void initializeLayout() {
        observationTextview = findViewById(R.id.observation_textview);
        observationSubTextview = findViewById(R.id.observation_sub_textview);
        btnNext = findViewById(R.id.btn_next);
        imgBack = findViewById(R.id.img_back);

        obClassArrayList.addAll(Helper.getList(Helper.observationClass, this, HseObservationClass.class));
        obSubClassArrayList_temp.addAll(Helper.getList(Helper.observationSubClass, this, HseObservationSubClass.class));

        observationClassAdapter = new ObservationClassAdapter(this, obClassArrayList);
        observationTextview.setAdapter(observationClassAdapter);

        //observation sub class items
        //for Unsafe
        //for condition
        //never miss
        //observationSubClassAdapter = new ObservationSubClassAdapter(this, obSubClassArrayList);
        //observationSubTextview.setAdapter(observationSubClassAdapter);
    }

    public boolean isValidate() {
        boolean returnValue = true;
        String message = "";

        if (observationSubClass.isEmpty()) {
            message = "Please select observation sub class.";
            returnValue = false;
        }

        if (observationClass.isEmpty()) {
            message = "Please select observation class.";
            returnValue = false;
        }

        if (!returnValue) {
            Toast.makeText(this, message, Toast.LENGTH_SHORT).show();
        }

        return returnValue;
    }
}