package com.utopiaindustries.hseobservationsapp.apiservice;

import com.utopiaindustries.hseobservationsapp.models.HseData.HseResponse;
import com.utopiaindustries.hseobservationsapp.models.QualityControl;
import com.utopiaindustries.hseobservationsapp.models.QualityControlResponse;
import com.utopiaindustries.hseobservationsapp.models.QualitySaveResponse;

import retrofit2.Call;
import retrofit2.http.Body;
import retrofit2.http.GET;
import retrofit2.http.POST;
import retrofit2.http.Query;

public interface ApiService {

    /*@GET("rest/uic/inspection-report")
    Call<List<Container>> fetchAllReports(
            @Query("username") String username
    );*/

    @GET("rest/uic/hse/get-hse-report-data")
    Call<HseResponse> getHseData();


    @POST("rest/uic/quality-control/save-quality-control")
    Call<QualitySaveResponse> saveQualityControlReport(
            @Body QualityControl request
    );

    @POST("rest/authentication/authenticate-user")
    Call<Boolean> isUserAuthenticated(
            @Query("username") String username,
            @Query("password") String password,
            @Query("roles") String[] roles
    );
}
